Index: CKEditor/trunk/_dev/releaser/release.bat
===================================================================
--- CKEditor/trunk/_dev/releaser/release.bat	(revision 6232)
+++ CKEditor/trunk/_dev/releaser/release.bat	(revision 6241)
@@ -11,3 +11,3 @@
 :: rmdir /S /Q release
 
-java -jar ckreleaser/ckreleaser.jar ckreleaser.release ../.. release "3.4.3 (SVN)" ckeditor_3.4.3_svn --run-before-release=langtool.bat
+java -jar ckreleaser/ckreleaser.jar ckreleaser.release ../.. release "3.5" ckeditor_3.5 --run-before-release=langtool.bat
Index: CKEditor/trunk/_dev/releaser/release.sh
===================================================================
--- CKEditor/trunk/_dev/releaser/release.sh	(revision 6232)
+++ CKEditor/trunk/_dev/releaser/release.sh	(revision 6241)
@@ -13,4 +13,4 @@
 
 pushd $DIR
-java -jar ckreleaser/ckreleaser.jar ckreleaser.release ../.. release "3.4.3 (SVN)" ckeditor_3.4.3_svn --run-before-release=$LANGTOOL
+java -jar ckreleaser/ckreleaser.jar ckreleaser.release ../.. release "3.5" ckeditor_3.5 --run-before-release=$LANGTOOL
 popd
Index: CKEditor/trunk/_samples/adobeair/run.bat
===================================================================
--- CKEditor/trunk/_samples/adobeair/run.bat	(revision 6241)
+++ CKEditor/trunk/_samples/adobeair/run.bat	(revision 6241)
@@ -0,0 +1,9 @@
+@ECHO OFF
+::
+:: Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+:: For licensing, see LICENSE.html or http://ckeditor.com/license
+::
+:: Use this file to quickly run the sample in a Windows environment.
+::
+
+adl application.xml ../../
Index: CKEditor/trunk/_samples/adobeair/run.sh
===================================================================
--- CKEditor/trunk/_samples/adobeair/run.sh	(revision 6241)
+++ CKEditor/trunk/_samples/adobeair/run.sh	(revision 6241)
@@ -0,0 +1,8 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+# For licensing, see LICENSE.html or http://ckeditor.com/license
+
+# Use this file to quickly run the sample under Linux.
+
+adl application.xml ../../
Index: CKEditor/trunk/_source/core/ckeditor_base.js
===================================================================
--- CKEditor/trunk/_source/core/ckeditor_base.js	(revision 6232)
+++ CKEditor/trunk/_source/core/ckeditor_base.js	(revision 6241)
@@ -13,5 +13,5 @@
 // ckeditor_source.js and ckeditor_basic_source.js files.
 
-// if(!window.CKEDITOR)window.CKEDITOR=(function(){var a={timestamp:'',version:'%VERSION%',rev:'%REV%',_:{},status:'unloaded',basePath:(function(){var d=window.CKEDITOR_BASEPATH||'';if(!d){var e=document.getElementsByTagName('script');for(var f=0;f<e.length;f++){var g=e[f].src.match(/(^|.*[\\\/])ckeditor(?:_basic)?(?:_source)?.js(?:\?.*)?$/i);if(g){d=g[1];break;}}}if(d.indexOf('://')==-1)if(d.indexOf('/')===0)d=location.href.match(/^.*?:\/\/[^\/]*/)[0]+d;else d=location.href.match(/^[^\?]*\/(?:)/)[0]+d;return d;})(),getUrl:function(d){if(d.indexOf('://')==-1&&d.indexOf('/')!==0)d=this.basePath+d;if(this.timestamp&&d.charAt(d.length-1)!='/')d+=(d.indexOf('?')>=0?'&':'?')+('t=')+this.timestamp;return d;}},b=window.CKEDITOR_GETURL;if(b){var c=a.getUrl;a.getUrl=function(d){return b.call(a,d)||c.call(a,d);};}return a;})();
+// if(!window.CKEDITOR)window.CKEDITOR=(function(){var a={timestamp:'',version:'%VERSION%',rev:'%REV%',_:{},status:'unloaded',basePath:(function(){var d=window.CKEDITOR_BASEPATH||'';if(!d){var e=document.getElementsByTagName('script');for(var f=0;f<e.length;f++){var g=e[f].src.match(/(^|.*[\\\/])ckeditor(?:_basic)?(?:_source)?.js(?:\?.*)?$/i);if(g){d=g[1];break;}}}if(d.indexOf(':/')==-1)if(d.indexOf('/')===0)d=location.href.match(/^.*?:\/\/[^\/]*/)[0]+d;else d=location.href.match(/^[^\?]*\/(?:)/)[0]+d;return d;})(),getUrl:function(d){if(d.indexOf(':/')==-1&&d.indexOf('/')!==0)d=this.basePath+d;if(this.timestamp&&d.charAt(d.length-1)!='/')d+=(d.indexOf('?')>=0?'&':'?')+('t=')+this.timestamp;return d;}},b=window.CKEDITOR_GETURL;if(b){var c=a.getUrl;a.getUrl=function(d){return b.call(a,d)||c.call(a,d);};}return a;})();
 
 // #### Raw code
@@ -127,5 +127,5 @@
 				// In IE (only) the script.src string is the raw valued entered in the
 				// HTML. Other browsers return the full resolved URL instead.
-				if ( path.indexOf('://') == -1 )
+				if ( path.indexOf(':/') == -1 )
 				{
 					// Absolute path.
@@ -169,5 +169,5 @@
 			{
 				// If this is not a full or absolute path.
-				if ( resource.indexOf('://') == -1 && resource.indexOf( '/' ) !== 0 )
+				if ( resource.indexOf(':/') == -1 && resource.indexOf( '/' ) !== 0 )
 					resource = this.basePath + resource;
 
Index: CKEditor/trunk/_source/core/config.js
===================================================================
--- CKEditor/trunk/_source/core/config.js	(revision 6232)
+++ CKEditor/trunk/_source/core/config.js	(revision 6241)
@@ -293,4 +293,5 @@
 		'horizontalrule,' +
 		'htmldataprocessor,' +
+		'iframe,' +
 		'image,' +
 		'indent,' +
Index: CKEditor/trunk/_source/core/dom/document.js
===================================================================
--- CKEditor/trunk/_source/core/dom/document.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/document.js	(revision 6241)
@@ -166,4 +166,7 @@
 		{
 			var head = this.$.getElementsByTagName( 'head' )[0];
+			if ( !head )
+				head = this.getDocumentElement().append( new CKEDITOR.dom.element( 'head' ), true );
+			else
 			head = new CKEDITOR.dom.element( head );
 
@@ -221,4 +224,28 @@
 					return win;
 				})();
+		},
+
+		/**
+		 * Defines the document contents through document.write. Note that the
+		 * previous document contents will be lost (cleaned).
+		 * @since 3.5
+		 * @param {String} html The HTML defining the document contents.
+		 * @example
+		 * document.write(
+		 *     '&lt;html&gt;' +
+		 *         '&lt;head&gt;&lt;title&gt;Sample Doc&lt;/title&gt;&lt;/head&gt;' +
+		 *         '&lt;body&gt;Document contents created by code&lt;/body&gt;' +
+		 *      '&lt;/html&gt;' );
+		 */
+		write : function( html )
+		{
+			// Don't leave any history log in IE. (#5657)
+			this.$.open( 'text/html', 'replace' );
+
+			// Support for custom document.domain in IE.
+			CKEDITOR.env.isCustomDomain() &&  ( this.$.domain = document.domain );
+
+			this.$.write( html );
+			this.$.close();
 		}
 	});
Index: CKEditor/trunk/_source/core/dom/domobject.js
===================================================================
--- CKEditor/trunk/_source/core/dom/domobject.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/domobject.js	(revision 6241)
@@ -168,4 +168,7 @@
 	 * Sets a data slot value for this object. These values are shared by all
 	 * instances pointing to that same DOM object.
+	 * <strong>Note:</strong> The created data slot is only guarantied to be available on this unique dom node,
+	 * thus any wish to continue access it from other element clones (either created by clone node or from innerHtml)
+	 * will fail, for such usage, please use {@link CKEDITOR.dom.element::setAttribute} instead.
 	 * @name CKEDITOR.dom.domObject.prototype.setCustomData
 	 * @function
@@ -201,5 +204,5 @@
 	domObjectProto.getCustomData = function( key )
 	{
-		var expandoNumber = this.$._cke_expando,
+		var expandoNumber = this.$[ 'data-cke-expando' ],
 			dataSlot = expandoNumber && customData[ expandoNumber ];
 
@@ -212,5 +215,5 @@
 	domObjectProto.removeCustomData = function( key )
 	{
-		var expandoNumber = this.$._cke_expando,
+		var expandoNumber = this.$[ 'data-cke-expando' ],
 			dataSlot = expandoNumber && customData[ expandoNumber ],
 			retval = dataSlot && dataSlot[ key ];
@@ -234,5 +237,5 @@
 		this.removeAllListeners();
 
-		var expandoNumber = this.$._cke_expando;
+		var expandoNumber = this.$[ 'data-cke-expando' ];
 		expandoNumber && delete customData[ expandoNumber ];
 	};
@@ -247,5 +250,5 @@
 	domObjectProto.getUniqueId = function()
 	{
-		return this.$._cke_expando || ( this.$._cke_expando = CKEDITOR.tools.getNextNumber() );
+		return this.$[ 'data-cke-expando' ] || ( this.$[ 'data-cke-expando' ] = CKEDITOR.tools.getNextNumber() );
 	};
 
Index: CKEditor/trunk/_source/core/dom/element.js
===================================================================
--- CKEditor/trunk/_source/core/dom/element.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/element.js	(revision 6241)
@@ -308,10 +308,14 @@
 		/**
 		 * Moves the selection focus to this element.
+		 * @param  {Boolean} defer Whether to asynchronously defer the
+		 * 		execution by 100 ms.
 		 * @example
 		 * var element = CKEDITOR.document.getById( 'myTextarea' );
 		 * <b>element.focus()</b>;
 		 */
-		focus : function()
-		{
+		focus : ( function()
+		{
+			function exec()
+			{
 			// IE throws error if the element is not visible.
 			try
@@ -321,5 +325,14 @@
 			catch (e)
 			{}
-		},
+			}
+
+			return function( defer )
+			{
+				if ( defer )
+					CKEDITOR.tools.setTimeout( exec, 100, this );
+				else
+					exec.call( this );
+			};
+		})(),
 
 		/**
@@ -726,5 +739,8 @@
 				var attribute = thisAttribs[ i ];
 
-				if ( ( !CKEDITOR.env.ie || ( attribute.specified && attribute.nodeName != '_cke_expando' ) ) && attribute.nodeValue != otherElement.getAttribute( attribute.nodeName ) )
+				if ( attribute.nodeName == '_moz_dirty' )
+					continue;
+
+				if ( ( !CKEDITOR.env.ie || ( attribute.specified && attribute.nodeName != 'data-cke-expando' ) ) && attribute.nodeValue != otherElement.getAttribute( attribute.nodeName ) )
 					return false;
 			}
@@ -737,5 +753,5 @@
 				{
 					attribute = otherAttribs[ i ];
-					if ( attribute.specified && attribute.nodeName != '_cke_expando'
+					if ( attribute.specified && attribute.nodeName != 'data-cke-expando'
 							&& attribute.nodeValue != this.getAttribute( attribute.nodeName ) )
 						return false;
@@ -787,5 +803,5 @@
 				var child = children.getItem( i );
 
-				if ( child.type == CKEDITOR.NODE_ELEMENT && child.getAttribute( '_cke_bookmark' ) )
+				if ( child.type == CKEDITOR.NODE_ELEMENT && child.data( 'cke-bookmark' ) )
 					continue;
 
@@ -832,5 +848,5 @@
 
 							// Attributes to be ignored.
-							case '_cke_expando' :
+							case 'data-cke-expando' :
 								continue;
 
@@ -852,5 +868,5 @@
 
 					// The _moz_dirty attribute might get into the element after pasting (#5455)
-					var execludeAttrs = { _cke_expando : 1, _moz_dirty : 1 };
+					var execludeAttrs = { 'data-cke-expando' : 1, _moz_dirty : 1 };
 
 					return attrsNum > 0 &&
@@ -915,5 +931,5 @@
 					var pendingNodes = [];
 
-					while ( sibling.getAttribute( '_cke_bookmark' )
+					while ( sibling.data( 'cke-bookmark' )
 						|| sibling.isEmptyInlineRemoveable() )
 					{
@@ -1481,5 +1497,5 @@
 			// Replace the node.
 			this.getParent() && this.$.parentNode.replaceChild( newNode.$, this.$ );
-			newNode.$._cke_expando = this.$._cke_expando;
+			newNode.$[ 'data-cke-expando' ] = this.$[ 'data-cke-expando' ];
 			this.$ = newNode.$;
 		},
@@ -1523,34 +1539,4 @@
 
 		/**
-		 *  Update the element's size with box model awareness.
-		 * @name CKEDITOR.dom.element.setSize
-		 * @param {String} type [width|height]
-		 * @param {Number} size The length unit in px.
-		 * @param isBorderBox Apply the {@param width} and {@param height} based on border box model.
-		 */
-		setSize : ( function()
-		{
-			var sides = {
-				width : [ "border-left-width", "border-right-width","padding-left", "padding-right" ],
-				height : [ "border-top-width", "border-bottom-width", "padding-top",  "padding-bottom" ]
-			};
-
-			return function( type, size, isBorderBox )
-				{
-					if ( typeof size == 'number' )
-					{
-						if ( isBorderBox && !( CKEDITOR.env.ie && CKEDITOR.env.quirks ) )
-						{
-							var	adjustment = 0;
-							for ( var i = 0, len = sides[ type ].length; i < len; i++ )
-								adjustment += parseInt( this.getComputedStyle( sides [ type ][ i ] ) || 0, 10 ) || 0;
-							size -= adjustment;
-						}
-						this.setStyle( type, size + 'px' );
-					}
-				};
-		})(),
-
-		/**
 		 * Gets element's direction. Supports both CSS 'direction' prop and 'dir' attr.
 		 */
@@ -1558,4 +1544,72 @@
 		{
 			return useComputed ? this.getComputedStyle( 'direction' ) : this.getStyle( 'direction' ) || this.getAttribute( 'dir' );
+		},
+
+		/**
+		 * Gets, sets and removes custom data to be stored as HTML5 data-* attributes.
+		 * @name CKEDITOR.dom.element.data
+		 * @param {String} name The name of the attribute, execluding the 'data-' part.
+		 * @param {String} [value] The value to set. If set to false, the attribute will be removed.
+		 */
+		data : function ( name, value )
+		{
+			name = 'data-' + name;
+			if ( value === undefined )
+				return this.getAttribute( name );
+			else if ( value === false )
+				this.removeAttribute( name );
+			else
+				this.setAttribute( name, value );
 		}
 	});
+
+( function()
+{
+	var sides = {
+		width : [ "border-left-width", "border-right-width","padding-left", "padding-right" ],
+		height : [ "border-top-width", "border-bottom-width", "padding-top",  "padding-bottom" ]
+	};
+
+	function marginAndPaddingSize( type )
+	{
+		var adjustment = 0;
+		for ( var i = 0, len = sides[ type ].length; i < len; i++ )
+			adjustment += parseInt( this.getComputedStyle( sides [ type ][ i ] ) || 0, 10 ) || 0;
+		return adjustment;
+	}
+
+	/**
+	 * Update the element's size with box model awareness.
+	 * @name CKEDITOR.dom.element.setSize
+	 * @param {String} type [width|height]
+	 * @param {Number} size The length unit in px.
+	 * @param isBorderBox Apply the {@param width} and {@param height} based on border box model.
+	 */
+	CKEDITOR.dom.element.prototype.setSize = function( type, size, isBorderBox )
+		{
+			if ( typeof size == 'number' )
+			{
+				if ( isBorderBox && !( CKEDITOR.env.ie && CKEDITOR.env.quirks ) )
+					size -= marginAndPaddingSize.call( this, type );
+
+				this.setStyle( type, size + 'px' );
+			}
+		};
+
+	/**
+	 * Get the element's size, possibly with box model awareness.
+	 * @name CKEDITOR.dom.element.getSize
+	 * @param {String} type [width|height]
+	 * @param {Boolean} contentSize Get the {@param width} or {@param height} based on border box model.
+	 */
+	CKEDITOR.dom.element.prototype.getSize = function( type, contentSize )
+		{
+			var size = Math.max( this.$[ 'offset' + CKEDITOR.tools.capitalize( type )  ],
+				this.$[ 'client' + CKEDITOR.tools.capitalize( type )  ] ) || 0;
+
+			if ( contentSize )
+				size -= marginAndPaddingSize.call( this, type );
+
+			return size;
+		};
+})();
Index: CKEditor/trunk/_source/core/dom/node.js
===================================================================
--- CKEditor/trunk/_source/core/dom/node.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/node.js	(revision 6241)
@@ -108,22 +108,23 @@
 			var $clone = this.$.cloneNode( includeChildren );
 
-			if ( !cloneId )
-			{
-				var removeIds = function( node )
-				{
-					if ( node.nodeType != CKEDITOR.NODE_ELEMENT )
-						return;
-
-					node.removeAttribute( 'id', false ) ;
-					node.removeAttribute( '_cke_expando', false ) ;
-
+			var removeIds = function( node )
+			{
+				if ( node.nodeType != CKEDITOR.NODE_ELEMENT )
+					return;
+
+				if ( !cloneId )
+					node.removeAttribute( 'id', false );
+				node.removeAttribute( 'data-cke-expando', false );
+
+				if ( includeChildren )
+				{
 					var childs = node.childNodes;
-					for ( var i=0 ; i < childs.length ; i++ )
+					for ( var i=0; i < childs.length; i++ )
 						removeIds( childs[ i ] );
-				};
-
-				// The "id" attribute should never be cloned to avoid duplication.
-				removeIds( $clone );
-			}
+				}
+			};
+
+			// The "id" attribute should never be cloned to avoid duplication.
+			removeIds( $clone );
 
 			return new CKEDITOR.dom.node( $clone );
@@ -244,11 +245,5 @@
 		getDocument : function()
 		{
-			var document = new CKEDITOR.dom.document( this.$.ownerDocument || this.$.parentNode.ownerDocument );
-
-			return (
-			this.getDocument = function()
-				{
-					return document;
-				})();
+			return new CKEDITOR.dom.document( this.$.ownerDocument || this.$.parentNode.ownerDocument );
 		},
 
Index: CKEditor/trunk/_source/core/dom/range.js
===================================================================
--- CKEditor/trunk/_source/core/dom/range.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/range.js	(revision 6241)
@@ -281,5 +281,5 @@
 				if ( CKEDITOR.tools.trim( node.getText() ).length )
 					return false;
-				}
+			}
 			else if ( node.type == CKEDITOR.NODE_ELEMENT )
 			{
@@ -309,5 +309,5 @@
 			    && node.getName() in CKEDITOR.dtd.$removeEmpty
 			    || !CKEDITOR.tools.trim( node.getText() )
-			    || node.getParent().hasAttribute( '_cke_bookmark' );
+			    || !!node.getParent().data( 'cke-bookmark' );
 	}
 
@@ -414,5 +414,5 @@
 
 			startNode = this.document.createElement( 'span' );
-			startNode.setAttribute( '_cke_bookmark', 1 );
+			startNode.data( 'cke-bookmark', 1 );
 			startNode.setStyle( 'display', 'none' );
 
@@ -724,8 +724,8 @@
 
 			if ( startNode.is && startNode.is( 'span' )
-				&& startNode.hasAttribute( '_cke_bookmark' ) )
+				&& startNode.data( 'cke-bookmark' ) )
 				this.setStartAt( startNode, CKEDITOR.POSITION_BEFORE_START );
 			if ( endNode && endNode.is && endNode.is( 'span' )
-				&& endNode.hasAttribute( '_cke_bookmark' ) )
+				&& endNode.data( 'cke-bookmark' ) )
 				this.setEndAt( endNode,  CKEDITOR.POSITION_AFTER_END );
 		},
@@ -933,5 +933,5 @@
 								// We need to check for the bookmark attribute because IE insists on
 								// rendering the display:none nodes we use for bookmarks. (#3363)
-								if ( sibling.$.offsetWidth > 0 && !sibling.getAttribute( '_cke_bookmark' ) )
+								if ( sibling.$.offsetWidth > 0 && !sibling.data( 'cke-bookmark' ) )
 								{
 									// We'll accept it only if we need
@@ -1092,5 +1092,5 @@
 								// We need to check for the bookmark attribute because IE insists on
 								// rendering the display:none nodes we use for bookmarks. (#3363)
-								if ( sibling.$.offsetWidth > 0 && !sibling.getAttribute( '_cke_bookmark' ) )
+								if ( sibling.$.offsetWidth > 0 && !sibling.data( 'cke-bookmark' ) )
 								{
 									// We'll accept it only if we need
Index: CKEditor/trunk/_source/core/dom/rangelist.js
===================================================================
--- CKEditor/trunk/_source/core/dom/rangelist.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/rangelist.js	(revision 6241)
@@ -114,5 +114,4 @@
 							range.moveToBookmark( bookmarks.shift() );
 
-							var next;
 							// Merge ranges finally after moving to bookmarks.
 							while( mergeCount-- )
Index: CKEditor/trunk/_source/core/dom/walker.js
===================================================================
--- CKEditor/trunk/_source/core/dom/walker.js	(revision 6232)
+++ CKEditor/trunk/_source/core/dom/walker.js	(revision 6241)
@@ -374,5 +374,5 @@
 			return ( node && node.getName
 					&& node.getName() == 'span'
-					&& node.hasAttribute( '_cke_bookmark' ) );
+					&& node.data( 'cke-bookmark' ) );
 		}
 
Index: CKEditor/trunk/_source/core/editor.js
===================================================================
--- CKEditor/trunk/_source/core/editor.js	(revision 6232)
+++ CKEditor/trunk/_source/core/editor.js	(revision 6241)
@@ -228,4 +228,7 @@
 		}
 
+		// Load the Adobe AIR plugin conditionally.
+		CKEDITOR.env.air && ( plugins += ',adobeair' );
+
 		// Load all plugins defined in the "plugins" setting.
 		CKEDITOR.plugins.load( plugins.split( ',' ), function( plugins )
@@ -757,4 +760,20 @@
 
 		/**
+		 * Insert text content into the currently selected position in the
+		 * editor, in WYSIWYG mode, styles of the selected element will be applied to the inserted text,
+		 * spaces around the text will be leaving untouched.
+		 * <strong>Note:</strong> two subsequent line-breaks will introduce one paragraph, which element depends on {@link CKEDITOR.config.enterMode};
+		 * A single line-break will be instead translated into one &lt;br /&gt;.
+		 * @since 3.5
+		 * @param {String} text Text to be inserted into the editor.
+		 * @example
+		 * CKEDITOR.instances.editor1.<b>insertText( ' line1 \n\n line2' )</b>;
+		 */
+		insertText : function( text )
+		{
+			this.fire( 'insertText', text );
+		},
+
+		/**
 		 * Inserts an element into the currently selected position in the
 		 * editor.
Index: CKEditor/trunk/_source/core/env.js
===================================================================
--- CKEditor/trunk/_source/core/env.js	(revision 6232)
+++ CKEditor/trunk/_source/core/env.js	(revision 6241)
@@ -242,5 +242,4 @@
 				env.gecko ? 'gecko' :
 				env.opera ? 'opera' :
-				env.air ? 'air' :
 				env.webkit ? 'webkit' :
 				'unknown' );
@@ -263,4 +262,7 @@
 			env.cssClass += ' cke_browser_gecko18';
 
+		if ( env.air )
+			env.cssClass += ' cke_browser_air';
+
 		return env;
 	})();
Index: CKEditor/trunk/_source/core/htmlparser/element.js
===================================================================
--- CKEditor/trunk/_source/core/htmlparser/element.js	(revision 6232)
+++ CKEditor/trunk/_source/core/htmlparser/element.js	(revision 6241)
@@ -35,5 +35,5 @@
 	this.children = [];
 
-	var tagName = attributes._cke_real_element_type || name;
+	var tagName = attributes[ 'data-cke-real-element-type' ] || name;
 
 	var dtd			= CKEDITOR.dtd,
Index: CKEditor/trunk/_source/core/htmlparser/fragment.js
===================================================================
--- CKEditor/trunk/_source/core/htmlparser/fragment.js	(revision 6232)
+++ CKEditor/trunk/_source/core/htmlparser/fragment.js	(revision 6241)
@@ -126,5 +126,5 @@
 				if ( element.attributes
 					 && ( realElementName =
-						  element.attributes[ '_cke_real_element_type' ] ) )
+						  element.attributes[ 'data-cke-real-element-type' ] ) )
 					elementName = realElementName;
 				else
Index: CKEditor/trunk/_source/core/loader.js
===================================================================
--- CKEditor/trunk/_source/core/loader.js	(revision 6232)
+++ CKEditor/trunk/_source/core/loader.js	(revision 6241)
@@ -60,10 +60,9 @@
 			'core/htmlparser/filter'	: [ 'core/htmlparser' ],
 			'core/htmlparser/basicwriter': [ 'core/htmlparser' ],
-			'core/imagecacher'		: [ 'core/dom/element', 'core/event' ],
 			'core/lang'				: [],
 			'core/plugins'			: [ 'core/resourcemanager' ],
 			'core/resourcemanager'	: [ 'core/scriptloader', 'core/tools' ],
 			'core/scriptloader'		: [ 'core/dom/element', 'core/env' ],
-			'core/skins'			: [ 'core/imagecacher', 'core/scriptloader' ],
+			'core/skins'			: [ 'core/scriptloader' ],
 			'core/themes'			: [ 'core/resourcemanager' ],
 			'core/tools'			: [ 'core/env' ],
Index: CKEditor/trunk/_source/core/skins.js
===================================================================
--- CKEditor/trunk/_source/core/skins.js	(revision 6232)
+++ CKEditor/trunk/_source/core/skins.js	(revision 6241)
@@ -18,5 +18,4 @@
 	// Holds the list of loaded skins.
 	var loaded = {},
-		preloaded = {},
 		paths = {};
 
@@ -53,31 +52,4 @@
 							return 'url(' + baseUrl + opener +  path + closer + ')';
 					} );
-		}
-
-		// Check if we need to preload images from it.
-		var preload = skinDefinition.preload;
-		if ( preload && preload.length > 0 )
-		{
-			if ( !preloaded[ skinName ] )
-			{
-				// Prepare image URLs
-				appendSkinPath( preload );
-
-				// Get preloader event dispatcher object.
-				preloaded[ skinName ] = CKEDITOR.imageCacher.load( preload );
-			}
-
-			if ( !preloaded[ skinName ].finished )
-			{
-				// Bind listener for this editor instance.
-				preloaded[ skinName ].on( 'loaded', function()
-					{
-						loadPart( editor, skinName, part, callback );
-					}
-				);
-
-				// Execution will be continued from event listener.
-				return;
-			}
 		}
 
Index: CKEditor/trunk/_source/core/tools.js
===================================================================
--- CKEditor/trunk/_source/core/tools.js	(revision 6232)
+++ CKEditor/trunk/_source/core/tools.js	(revision 6241)
@@ -639,5 +639,5 @@
 			return functions.push( function()
 				{
-					fn.apply( scope || this, arguments );
+					return fn.apply( scope || this, arguments );
 				}) - 1;
 		},
Index: CKEditor/trunk/_source/core/ui.js
===================================================================
--- CKEditor/trunk/_source/core/ui.js	(revision 6232)
+++ CKEditor/trunk/_source/core/ui.js	(revision 6241)
@@ -92,4 +92,6 @@
 };
 
+CKEDITOR.event.implementOn( CKEDITOR.ui );
+
 /**
  * (Virtual Class) Do not call this constructor. This class is not really part
Index: CKEditor/trunk/_source/lang/af.js
===================================================================
--- CKEditor/trunk/_source/lang/af.js	(revision 6232)
+++ CKEditor/trunk/_source/lang/af.js	(revision 6241)
@@ -57,4 +57,5 @@
 	horizontalrule	: 'Horisontale lyn byvoeg',
 	pagebreak		: 'Bladsy breek byvoeg',
+	pagebreakAlt		: 'Page Break', // MISSING
 	unlink			: 'Skakel verweider',
 	undo			: 'Ont-skep',
@@ -110,4 +111,15 @@
 		styles			: 'Style', // MISSING
 		cssClasses		: 'Stylesheet Classes', // MISSING
+		width			: 'Weidte',
+		height			: 'Hoogde',
+		align			: 'Paradeer',
+		alignLeft		: 'Links',
+		alignRight		: 'Regs',
+		alignCenter		: 'Middel',
+		alignTop		: 'Bo',
+		alignMiddle		: 'Middel',
+		alignBottom		: 'Onder',
+		invalidHeight	: 'Height must be a number.', // MISSING
+		invalidWidth	: 'Width must be a number.', // MISSING
 
 		// Put the voice-only part of the label in the span.
@@ -156,7 +168,5 @@
 		popupScrollBars	: 'Gleibalkstuk',
 		popupDependent	: 'Afhanklik (Netscape)',
-		popupWidth		: 'Weite',
 		popupLeft		: 'Links Posisie',
-		popupHeight		: 'Hoogde',
 		popupTop		: 'Bo Posisie',
 		id				: 'Id', // MISSING
@@ -244,13 +254,7 @@
 		columns		: 'Kolome',
 		border		: 'Kant groote',
-		align		: 'Parideering',
-		alignLeft	: 'Links',
-		alignCenter	: 'Middel',
-		alignRight	: 'Regs',
-		width		: 'Weite',
 		widthPx		: 'pixels',
 		widthPc		: 'percent',
 		widthUnit	: 'width unit', // MISSING
-		height		: 'Hoogde',
 		cellSpace	: 'Cell spasieering',
 		cellPad		: 'Cell buffer',
@@ -288,7 +292,4 @@
 			hAlign			: 'Horizontal Alignment', // MISSING
 			vAlign			: 'Vertical Alignment', // MISSING
-			alignTop		: 'Top', // MISSING
-			alignMiddle		: 'Middle', // MISSING
-			alignBottom		: 'Bottom', // MISSING
 			alignBaseline	: 'Baseline', // MISSING
 			bgColor			: 'Background Color', // MISSING
@@ -411,6 +412,4 @@
 		upload		: 'Uplaai',
 		alt			: 'Alternatiewe beskrywing',
-		width		: 'Weidte',
-		height		: 'Hoogde',
 		lockRatio	: 'Behou preporsie',
 		unlockRatio	: 'Unlock Ratio', // MISSING
@@ -419,7 +418,4 @@
 		hSpace		: 'HSpasie',
 		vSpace		: 'VSpasie',
-		align		: 'Paradeer',
-		alignLeft	: 'Links',
-		alignRight	: 'Regs',
 		alertUrl	: 'Voeg asseblief Beeld URL in.',
 		linkTab		: 'Skakel',
@@ -427,6 +423,4 @@
 		img2Button	: 'Do you want to transform the selected image on a image button?', // MISSING
 		urlMissing	: 'Image source URL is missing.', // MISSING
-		validateWidth	: 'Width must be a whole number.', // MISSING
-		validateHeight	: 'Height must be a whole number.', // MISSING
 		validateBorder	: 'Border must be a whole number.', // MISSING
 		validateHSpace	: 'HSpace must be a whole number.', // MISSING
@@ -452,14 +446,8 @@
 		accessSameDomain: 'Same domain', // MISSING
 		accessNever		: 'Never', // MISSING
-		align			: 'Paradeer',
-		alignLeft		: 'Links',
 		alignAbsBottom	: 'Abs Onder',
 		alignAbsMiddle	: 'Abs Middel',
 		alignBaseline	: 'Baseline',
-		alignBottom		: 'Onder',
-		alignMiddle		: 'Middel',
-		alignRight		: 'Regs',
 		alignTextTop	: 'Text Bo',
-		alignTop		: 'Bo',
 		quality			: 'Quality', // MISSING
 		qualityBest		: 'Best', // MISSING
@@ -475,11 +463,7 @@
 		flashvars		: 'Variables for Flash', // MISSING
 		bgcolor			: 'Agtergrond kleur',
-		width			: 'Weidte',
-		height			: 'Hoogde',
 		hSpace			: 'HSpasie',
 		vSpace			: 'VSpasie',
 		validateSrc		: 'Voeg asseblief die URL in',
-		validateWidth	: 'Width must be a number.', // MISSING
-		validateHeight	: 'Height must be a number.', // MISSING
 		validateHSpace	: 'HSpace must be a number.', // MISSING
 		validateVSpace	: 'VSpace must be a number.' // MISSING
@@ -615,4 +599,13 @@
 		remove				: 'Remove Div' // MISSING
   	},
+
+	iframe :
+	{
+		title		: 'iFrame Properties', // MISSING
+		toolbar		: 'iFrame', // MISSING
+		noUrl		: 'Please type the iFrame URL', // MISSING
+		scrolling	: 'Enable scrollbars', // MISSING
+		border		: 'Show frame border' // MISSING
+	},
 
 	font :
@@ -731,8 +724,9 @@
 	fakeobjects :
 	{
-		anchor	: 'Anchor', // MISSING
-		flash	: 'Flash Animation', // MISSING
-		div		: 'Page Break', // MISSING
-		unknown	: 'Unknown Object' // MISSING
+		anchor		: 'Anchor', // MISSING
+		flash		: 'Flash Animation', // MISSING
+		iframe		: 'iFrame', // MISSING
+		hiddenfield	: 'Hidden Field', // MISSING
+		unknown		: 'Unknown Object' // MISSING
 	},
 
